Index: drivers/filesystems/btrfs/read.c
===================================================================
--- drivers/filesystems/btrfs/read.c	(révision 74430)
+++ drivers/filesystems/btrfs/read.c	(copie de travail)
@@ -2019,278 +641,291 @@
 #endif
     }
     
-    if (checksum_error) {
-        CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&ci[1];
+    if (!checksum_error)
+        return STATUS_SUCCESS;
+    
+    if (c) {
+        get_raid56_lock_range(c, addr, length, &lockaddr, &locklen);
+        chunk_lock_range(Vcb, c, lockaddr, locklen);
+    }
+    
+    if (context->tree) {
+        UINT16 j, parity;
+        UINT64 off;
+        BOOL recovered = FALSE, first = TRUE, failed = FALSE;
+        UINT8* t2;
         
-        if (needs_reconstruct) {
-            PIO_STACK_LOCATION IrpSp;
-#ifdef DEBUG_STATS
-            LARGE_INTEGER time1, time2;
-#endif
-            
-            // re-run Irp that we cancelled
-            
-            if (context->stripes[reconstruct_stripe].Irp) {
-                if (devices[reconstruct_stripe]->devobj->Flags & DO_DIRECT_IO) {
-                    MmUnlockPages(context->stripes[reconstruct_stripe].Irp->MdlAddress);
-                    IoFreeMdl(context->stripes[reconstruct_stripe].Irp->MdlAddress);
-                }
-                IoFreeIrp(context->stripes[reconstruct_stripe].Irp);
-            }
-            
-            if (!Irp) {
-                context->stripes[reconstruct_stripe].Irp = IoAllocateIrp(devices[reconstruct_stripe]->devobj->StackSize, FALSE);
-                
-                if (!context->stripes[reconstruct_stripe].Irp) {
-                    ERR("IoAllocateIrp failed\n");
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-            } else {
-                context->stripes[reconstruct_stripe].Irp = IoMakeAssociatedIrp(Irp, devices[reconstruct_stripe]->devobj->StackSize);
-                
-                if (!context->stripes[reconstruct_stripe].Irp) {
-                    ERR("IoMakeAssociatedIrp failed\n");
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-            }
-            
-            IrpSp = IoGetNextIrpStackLocation(context->stripes[reconstruct_stripe].Irp);
-            IrpSp->MajorFunction = IRP_MJ_READ;
-            
-            if (devices[reconstruct_stripe]->devobj->Flags & DO_BUFFERED_IO) {
-                FIXME("FIXME - buffered IO\n");
-            } else if (devices[reconstruct_stripe]->devobj->Flags & DO_DIRECT_IO) {
-                context->stripes[reconstruct_stripe].Irp->MdlAddress = IoAllocateMdl(context->stripes[reconstruct_stripe].buf,
-                                                                                        stripeend[reconstruct_stripe] - stripestart[reconstruct_stripe], FALSE, FALSE, NULL);
-                if (!context->stripes[reconstruct_stripe].Irp->MdlAddress) {
-                    ERR("IoAllocateMdl failed\n");
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-                
-                MmProbeAndLockPages(context->stripes[reconstruct_stripe].Irp->MdlAddress, KernelMode, IoWriteAccess);
-            } else {
-                context->stripes[reconstruct_stripe].Irp->UserBuffer = context->stripes[reconstruct_stripe].buf;
-            }
-
-            IrpSp->Parameters.Read.Length = stripeend[reconstruct_stripe] - stripestart[reconstruct_stripe];
-            IrpSp->Parameters.Read.ByteOffset.QuadPart = stripestart[reconstruct_stripe] + cis[reconstruct_stripe].offset;
-            
-            context->stripes[reconstruct_stripe].Irp->UserIosb = &context->stripes[reconstruct_stripe].iosb;
-            
-            IoSetCompletionRoutine(context->stripes[reconstruct_stripe].Irp, read_data_completion, &context->stripes[reconstruct_stripe], TRUE, TRUE, TRUE);
-
-            context->stripes[reconstruct_stripe].status = ReadDataStatus_Pending;
-            
-            context->stripes_left = 1;
-            KeClearEvent(&context->Event);
-            
-#ifdef DEBUG_STATS
-            if (!context->tree)
-                time1 = KeQueryPerformanceCounter(NULL);
-#endif
-
-            IoCallDriver(devices[reconstruct_stripe]->devobj, context->stripes[reconstruct_stripe].Irp);
-            
-            KeWaitForSingleObject(&context->Event, Executive, KernelMode, FALSE, NULL);
-            
-#ifdef DEBUG_STATS
-            if (!context->tree) {
-                time2 = KeQueryPerformanceCounter(NULL);
-                
-                Vcb->stats.read_disk_time += time2.QuadPart - time1.QuadPart;
-            }
-#endif
-
-            if (context->stripes[reconstruct_stripe].status != ReadDataStatus_Success) {
-                ERR("unrecoverable checksum error\n");
-                return STATUS_CRC_ERROR;
-            }
+        t2 = ExAllocatePoolWithTag(NonPagedPool, Vcb->superblock.node_size * 2, ALLOC_TAG);
+        if (!t2) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto end;
         }
         
-        if (context->tree) {
-            off = origoff;
-            pos = 0;
-            stripeoff = 0;
-            if (!raid5_decode_with_checksum_metadata(addr, off, skip, context, ci, &stripeoff, buf, &pos, length, firststripesize, Vcb->superblock.node_size)) {
-                ERR("unrecoverable metadata checksum error\n");
-                return STATUS_CRC_ERROR;
+        get_raid0_offset(addr - offset, ci->stripe_length, ci->num_stripes - 1, &off, &stripe);
+        
+        parity = (((addr - offset) / ((ci->num_stripes - 1) * ci->stripe_length)) + ci->num_stripes - 1) % ci->num_stripes;
+        
+        stripe = (parity + stripe + 1) % ci->num_stripes;
+        
+        for (j = 0; j < ci->num_stripes; j++) {
+            if (j != stripe) {
+                if (devices[j]->devobj) {
+                    if (first) {
+                        Status = sync_read_phys(devices[j]->devobj, cis[j].offset + off, Vcb->superblock.node_size, t2, FALSE);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("sync_read_phys returned %08x\n", Status);
+                            log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_READ_ERRORS);
+                            failed = TRUE;
+                            break;
+                        }
+                        
+                        first = FALSE;
+                    } else {
+                        Status = sync_read_phys(devices[j]->devobj, cis[j].offset + off, Vcb->superblock.node_size, t2 + Vcb->superblock.node_size, FALSE);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("sync_read_phys returned %08x\n", Status);
+                            log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_READ_ERRORS);
+                            failed = TRUE;
+                            break;
+                        }
+                        
+                        do_xor(t2, t2 + Vcb->superblock.node_size, Vcb->superblock.node_size);
+                    }
+                } else {
+                    failed = TRUE;
+                    break;
+                }
             }
-        } else {
-            off = origoff;
-            pos = 0;
-            stripeoff = 0;
-            if (!raid5_decode_with_checksum(off, skip, context, ci, &stripeoff, buf, &pos, length, firststripesize, context->csum, Vcb->superblock.sector_size))
-                return STATUS_CRC_ERROR;
-            
-            while (pos < length) {
-                off += (ci->num_stripes - 1) * ci->stripe_length;
-                if (!raid5_decode_with_checksum(off, 0, context, ci, &stripeoff, buf, &pos, length, 0, context->csum, Vcb->superblock.sector_size))
-                    return STATUS_CRC_ERROR;
-            }
         }
         
-        // write good data over bad
-        
-        if (!Vcb->readonly) {
-            for (i = 0; i < ci->num_stripes; i++) {
-                if (context->stripes[i].rewrite && devices[i] && !devices[i]->readonly) {
-                    Status = write_data_phys(devices[i]->devobj, cis[i].offset + stripestart[i], context->stripes[i].buf, stripeend[i] - stripestart[i]);
-                    
-                    if (!NT_SUCCESS(Status))
+        if (!failed) {
+            tree_header* t3 = (tree_header*)t2;
+            UINT32 crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&t3->fs_uuid, Vcb->superblock.node_size - sizeof(t3->csum));
+
+            if (t3->address == addr && crc32 == *((UINT32*)t3->csum) && (generation == 0 || t3->generation == generation)) {
+                RtlCopyMemory(buf, t2, Vcb->superblock.node_size);
+                ERR("recovering from checksum error at %llx, device %llx\n", addr, devices[stripe]->devitem.dev_id);
+                recovered = TRUE;
+                
+                if (!Vcb->readonly && !devices[stripe]->readonly) { // write good data over bad
+                    Status = write_data_phys(devices[stripe]->devobj, cis[stripe].offset + off, t2, Vcb->superblock.node_size);
+                    if (!NT_SUCCESS(Status)) {
                         WARN("write_data_phys returned %08x\n", Status);
+                        log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_WRITE_ERRORS);
+                    }
                 }
             }
         }
-    }
-    
-    if (check_nocsum_parity && !context->tree && !context->csum) {
-        UINT32* parity_buf;
+
+        if (!recovered) {
+            ERR("unrecoverable checksum error at %llx\n", addr);
+            ExFreePool(t2);
+            Status = STATUS_CRC_ERROR;
+            goto end;
+        }
         
-        // We are reading a nodatacsum extent. Even though there's no checksum, we
-        // can still identify errors by checking if the parity is consistent.
+        ExFreePool(t2);
+    } else {
+        ULONG sectors = length / Vcb->superblock.sector_size;
+        UINT8* sector;
         
-        parity_buf = ExAllocatePoolWithTag(NonPagedPool, stripeend[0] - stripestart[0], ALLOC_TAG);
-        
-        if (!parity_buf) {
+        sector = ExAllocatePoolWithTag(NonPagedPool, Vcb->superblock.sector_size * 2, ALLOC_TAG);
+        if (!sector) {
             ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto end;
         }
         
-        RtlCopyMemory(parity_buf, context->stripes[0].buf, stripeend[0] - stripestart[0]);
-        
-        for (i = 0; i < ci->num_stripes; i++) {
-            do_xor((UINT8*)parity_buf, context->stripes[i].buf, stripeend[0] - stripestart[0]);
-        }
-        
-        for (i = 0; i < (stripeend[0] - stripestart[0]) / sizeof(UINT32); i++) {
-            if (parity_buf[i] != 0) {
-                ERR("parity error on nodatacsum inode\n");
-                ExFreePool(parity_buf);
-                return STATUS_CRC_ERROR;
+        for (i = 0; i < sectors; i++) {
+            UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+            
+            if (context->csum[i] != crc32) {
+                UINT16 j, parity;
+                UINT64 off;
+                BOOL recovered = FALSE, first = TRUE, failed = FALSE;
+                
+                get_raid0_offset(addr - offset + UInt32x32To64(i, Vcb->superblock.sector_size), ci->stripe_length,
+                                 ci->num_stripes - 1, &off, &stripe);
+                
+                parity = (((addr - offset + UInt32x32To64(i, Vcb->superblock.sector_size)) / ((ci->num_stripes - 1) * ci->stripe_length)) + ci->num_stripes - 1) % ci->num_stripes;
+                
+                stripe = (parity + stripe + 1) % ci->num_stripes;
+                log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_READ_ERRORS);
+                
+                for (j = 0; j < ci->num_stripes; j++) {
+                    if (j != stripe) {
+                        if (devices[j]->devobj) {
+                            if (first) {
+                                Status = sync_read_phys(devices[j]->devobj, cis[j].offset + off, Vcb->superblock.sector_size, sector, FALSE);
+                                if (!NT_SUCCESS(Status)) {
+                                    ERR("sync_read_phys returned %08x\n", Status);
+                                    failed = TRUE;
+                                    log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_READ_ERRORS);
+                                    break;
+                                }
+                                
+                                first = FALSE;
+                            } else {
+                                Status = sync_read_phys(devices[j]->devobj, cis[j].offset + off, Vcb->superblock.sector_size, sector + Vcb->superblock.sector_size, FALSE);
+                                if (!NT_SUCCESS(Status)) {
+                                    ERR("sync_read_phys returned %08x\n", Status);
+                                    failed = TRUE;
+                                    log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_READ_ERRORS);
+                                    break;
+                                }
+                                
+                                do_xor(sector, sector + Vcb->superblock.sector_size, Vcb->superblock.sector_size);
+                            }
+                        } else {
+                            failed = TRUE;
+                            break;
+                        }
+                    }
+                }
+                
+                if (!failed) {
+                    crc32 = ~calc_crc32c(0xffffffff, sector, Vcb->superblock.sector_size);
+                    
+                    if (crc32 == context->csum[i]) {
+                        RtlCopyMemory(buf + (i * Vcb->superblock.sector_size), sector, Vcb->superblock.sector_size);
+                        ERR("recovering from checksum error at %llx, device %llx\n", addr + UInt32x32To64(i, Vcb->superblock.sector_size), devices[stripe]->devitem.dev_id);
+                        recovered = TRUE;
+                        
+                        if (!Vcb->readonly && !devices[stripe]->readonly) { // write good data over bad
+                            Status = write_data_phys(devices[stripe]->devobj, cis[stripe].offset + off,
+                                                     sector, Vcb->superblock.sector_size);
+                            if (!NT_SUCCESS(Status)) {
+                                WARN("write_data_phys returned %08x\n", Status);
+                                log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_WRITE_ERRORS);
+                            }
+                        }
+                    }
+                }
+
+                if (!recovered) {
+                    ERR("unrecoverable checksum error at %llx\n", addr + UInt32x32To64(i, Vcb->superblock.sector_size));
+                    ExFreePool(sector);
+                    Status = STATUS_CRC_ERROR;
+                    goto end;
+                }
             }
         }
         
-        ExFreePool(parity_buf);
+        ExFreePool(sector);
     }
+
+    Status = STATUS_SUCCESS;
     
-    return STATUS_SUCCESS;
+end:
+    if (c)
+        chunk_unlock_range(Vcb, c, lockaddr, locklen);
+
+    return Status;
 }
 
-static NTSTATUS read_data_raid6(device_extension* Vcb, UINT8* buf, UINT64 addr, UINT32 length, PIRP Irp, read_data_context* context, CHUNK_ITEM* ci,
-                                device** devices, UINT64* stripestart, UINT64* stripeend, UINT64 offset, UINT32 firststripesize, BOOL check_nocsum_parity) {
-    NTSTATUS Status;
-    UINT32 pos, skip;
-    int num_errors = 0;
-    UINT64 i, off, stripeoff, origoff;
-    UINT8 needs_reconstruct = 0;
-    UINT16 missing1, missing2;
-    BOOL checksum_error = FALSE;
-    
-    for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].status == ReadDataStatus_Error) {
-            num_errors++;
-            if (num_errors > 2)
-                break;
-        }
-    }
-    
-    if (num_errors > 2) {
-        for (i = 0; i < ci->num_stripes; i++) {
-            if (context->stripes[i].status == ReadDataStatus_Error) {
-                WARN("stripe %llu returned error %08x\n", i, context->stripes[i].iosb.Status); 
-                return context->stripes[i].iosb.Status;
-            }
-        }
-    }
-    
-    off = addr - offset;
-    off -= off % ((ci->num_stripes - 2) * ci->stripe_length);
-    skip = addr - offset - off;
-    origoff = off;
-    
-    for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].status == ReadDataStatus_Cancelled) {
-            if (needs_reconstruct == 2) {
-                ERR("more than two stripes need reconstruction\n");
-                return STATUS_INTERNAL_ERROR;
-            } else if (needs_reconstruct == 1) {
-                needs_reconstruct++;
-                missing2 = i;
-            } else {
-                needs_reconstruct++;
-                missing1 = i;
-            }
-        }
-    }
-    
-    if (needs_reconstruct > 0) {
-        stripeoff = 0;
+static void raid6_recover2(UINT8* sectors, UINT16 num_stripes, ULONG sector_size, UINT16 missing1, UINT16 missing2, UINT8* out) {
+    if (missing1 == num_stripes - 2 || missing2 == num_stripes - 2) { // reconstruct from q and data
+        UINT16 missing = missing1 == (num_stripes - 2) ? missing2 : missing1;
+        UINT16 stripe;
         
-        if (needs_reconstruct == 2) {
-            TRACE("reconstructing stripes %u and %u\n", missing1, missing2);
+        stripe = num_stripes - 3;
         
-            raid6_reconstruct2(off, skip, context, ci, &stripeoff, stripeend[missing1] - stripestart[missing1],
-                                TRUE, firststripesize, missing1, missing2);
+        if (stripe == missing)
+            RtlZeroMemory(out, sector_size);
+        else
+            RtlCopyMemory(out, sectors + (stripe * sector_size), sector_size);
+
+        do {
+            stripe--;
             
-            while (stripeoff < stripeend[0] - stripestart[0]) {
-                off += (ci->num_stripes - 2) * ci->stripe_length;
-                raid6_reconstruct2(off, 0, context, ci, &stripeoff, stripeend[missing1] - stripestart[missing1],
-                                    FALSE, 0, missing1, missing2);
-            }
+            galois_double(out, sector_size);
+            
+            if (stripe != missing)
+                do_xor(out, sectors + (stripe * sector_size), sector_size);
+        } while (stripe > 0);
+        
+        do_xor(out, sectors + ((num_stripes - 1) * sector_size), sector_size);
+        
+        if (missing != 0)
+            galois_divpower(out, missing, sector_size);
+    } else { // reconstruct from p and q
+        UINT16 x, y, stripe;
+        UINT8 gyx, gx, denom, a, b, *p, *q, *pxy, *qxy;
+        UINT32 j;
+        
+        stripe = num_stripes - 3;
+        
+        pxy = out + sector_size;
+        qxy = out; 
+
+        if (stripe == missing1 || stripe == missing2) {
+            RtlZeroMemory(qxy, sector_size);
+            RtlZeroMemory(pxy, sector_size);
+            
+            if (stripe == missing1)
+                x = stripe;
+            else
+                y = stripe;
         } else {
-            TRACE("reconstructing stripe %u\n", missing1);
+            RtlCopyMemory(qxy, sectors + (stripe * sector_size), sector_size);
+            RtlCopyMemory(pxy, sectors + (stripe * sector_size), sector_size);
+        }
+
+        do {
+            stripe--;
             
-            raid6_reconstruct1(off, skip, context, ci, &stripeoff, stripeend[missing1] - stripestart[missing1], TRUE, firststripesize, missing1);
+            galois_double(qxy, sector_size);
             
-            while (stripeoff < stripeend[0] - stripestart[0]) {
-                off += (ci->num_stripes - 2) * ci->stripe_length;
-                raid6_reconstruct1(off, 0, context, ci, &stripeoff, stripeend[missing1] - stripestart[missing1], FALSE, 0, missing1);
-            }
-        }
+            if (stripe != missing1 && stripe != missing2) {
+                do_xor(qxy, sectors + (stripe * sector_size), sector_size);
+                do_xor(pxy, sectors + (stripe * sector_size), sector_size);
+            } else if (stripe == missing1)
+                x = stripe;
+            else if (stripe == missing2)
+                y = stripe;
+        } while (stripe > 0);
         
-        off = origoff;
-    }
-    
-    if (check_nocsum_parity && !context->tree && !context->csum) {
-        UINT8* scratch;
+        gyx = gpow2(y > x ? (y-x) : (255-x+y));
+        gx = gpow2(255-x);
+
+        denom = gdiv(1, gyx ^ 1);
+        a = gmul(gyx, denom);
+        b = gmul(gx, denom);
         
-        scratch = ExAllocatePoolWithTag(NonPagedPool, ci->stripe_length, ALLOC_TAG);
-        if (!scratch) {
-            ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
+        p = sectors + ((num_stripes - 2) * sector_size);
+        q = sectors + ((num_stripes - 1) * sector_size);
         
-        stripeoff = 0;
-        Status = check_raid6_nocsum_parity(off, skip, context, ci, &stripeoff, stripeend[0] - stripestart[0], TRUE, firststripesize, scratch);
-        if (!NT_SUCCESS(Status)) {
-            ERR("check_raid6_nocsum_parity returned %08x\n", Status);
-            ExFreePool(scratch);
-            return Status;
-        }
+        for (j = 0; j < sector_size; j++) {
+            *qxy = gmul(a, *p ^ *pxy) ^ gmul(b, *q ^ *qxy);
             
-        while (stripeoff < stripeend[0] - stripestart[0]) {
-            off += (ci->num_stripes - 2) * ci->stripe_length;
-            Status = check_raid6_nocsum_parity(off, 0, context, ci, &stripeoff, stripeend[0] - stripestart[0], FALSE, 0, scratch);
-            
-            if (!NT_SUCCESS(Status)) {
-                ERR("check_raid6_nocsum_parity returned %08x\n", Status);
-                ExFreePool(scratch);
-                return Status;
-            }
+            p++;
+            q++;
+            pxy++;
+            qxy++;
         }
         
-        ExFreePool(scratch);
-        
-        off = origoff;
+        do_xor(out + sector_size, out, sector_size);
+        do_xor(out + sector_size, sectors + ((num_stripes - 2) * sector_size), sector_size);
     }
+}
+
+static NTSTATUS read_data_raid6(device_extension* Vcb, UINT8* buf, UINT64 addr, UINT32 length, read_data_context* context, CHUNK_ITEM* ci,
+                                device** devices, UINT64 offset, UINT64 generation, chunk* c) {
+    NTSTATUS Status;
+    ULONG i;
+    BOOL checksum_error = FALSE;
+    CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&ci[1];
+    UINT64 lockaddr, locklen;
+    UINT16 stripe;
     
-    pos = 0;
-    stripeoff = 0;
-    raid6_decode(off, skip, context, ci, &stripeoff, buf, &pos, length, firststripesize);
-    
-    while (pos < length) {
-        off += (ci->num_stripes - 2) * ci->stripe_length;
-        raid6_decode(off, 0, context, ci, &stripeoff, buf, &pos, length, 0);
+    for (i = 0; i < ci->num_stripes; i++) {
+        if (context->stripes[i].status == ReadDataStatus_Error) {
+            WARN("stripe %llu returned error %08x\n", i, context->stripes[i].iosb.Status);
+            log_device_error(Vcb, devices[i], BTRFS_DEV_STAT_READ_ERRORS);
+            return context->stripes[i].iosb.Status;
+        } else if (context->stripes[i].status == ReadDataStatus_Success)
+            stripe = i;
     }
     
     if (context->tree) {
@@ -2297,8 +932,13 @@
         tree_header* th = (tree_header*)buf;
         UINT32 crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, Vcb->superblock.node_size - sizeof(th->csum));
         
-        if (addr != th->address || crc32 != *((UINT32*)th->csum))
+        if (addr != th->address || crc32 != *((UINT32*)th->csum)) {
             checksum_error = TRUE;
+            log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+        } else if (generation != 0 && generation != th->generation) {
+            checksum_error = TRUE;
+            log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_GENERATION_ERRORS);
+        }
     } else if (context->csum) {
 #ifdef DEBUG_STATS
         LARGE_INTEGER time1, time2;
